import "antd/es/button/style";
import _Button from "antd/es/button";
import "antd/es/message/style";
import _message from "antd/es/message";
import "antd/es/modal/style";
import _Modal from "antd/es/modal";
/*
 * @Author: chenzenghua
 * @Date: 2021-07-26 11:40:34
 * @Last Modified by:   chenzenghua
 * @Last Modified time: 2021-07-26 11:40:34
 * @Des: 弹出消息窗
 */

import { CheckCircleFilled, CheckOutlined, CloseCircleOutlined, InfoCircleFilled, QuestionCircleOutlined, WarningOutlined } from '@ant-design/icons';
import { Slide, toast } from 'react-toastify';
// import 'react-toastify/dist/ReactToastify.css'

import React from 'react';
import XDraggableModal from "../XDraggableModal";
import "./style.less";
var _confirm = _Modal.confirm;

// 默认配置

var defaultConfig = {
  autoClose: 2000,
  // false or number
  position: 'top-center',
  draggablePercent: 30,
  pauseOnFocusLoss: false,
  transition: Slide
};
toast.configure(defaultConfig);
var showMsg = function showMsg(type, content, options) {
  var MsgBody = /*#__PURE__*/React.createElement("div", {
    className: "contentWrapper"
  }, /*#__PURE__*/React.createElement("div", {
    className: "icon"
  }, type === 'error' && /*#__PURE__*/React.createElement(CloseCircleOutlined, {
    style: {
      color: '#fa5151',
      fontSize: '14px'
    }
  }), type === 'success' && /*#__PURE__*/React.createElement(CheckCircleFilled, {
    style: {
      color: '#00a200',
      fontSize: '14px'
    }
  }), type === 'info' && /*#__PURE__*/React.createElement(InfoCircleFilled, {
    style: {
      color: '#1890FF',
      fontSize: '14px'
    }
  }), type === 'warn' && /*#__PURE__*/React.createElement(WarningOutlined, {
    style: {
      color: '#bf6518',
      fontSize: '14px'
    }
  })), /*#__PURE__*/React.createElement("div", {
    className: "msgContent"
  }, content));
  switch (type) {
    case 'error':
      toast.error(MsgBody, options);
      break;
    case 'success':
      toast.success(MsgBody, options);
      break;
    case 'info':
      toast.info(MsgBody, options);
      break;
    case 'warn':
      toast.warn(MsgBody, options);
      break;
    case 'loading':
      toast.warn(MsgBody, options);
      break;
    default:
      toast(MsgBody, options);
      break;
  }
};
var msg = {
  error: function error(content, options) {
    return showMsg('error', content, options);
  },
  info: function info(content, options) {
    return showMsg('info', content, options);
  },
  success: function success(content, options) {
    return showMsg('success', content, options);
  },
  warn: function warn(content, options) {
    return showMsg('warn', content, options);
  },
  loading: function loading() {
    var content = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'Loading...';
    var key = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'loading';
    return _message.loading({
      content: content,
      key: key
    });
  },
  loadingComplete: function loadingComplete() {
    var content = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '完成!';
    var key = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'loading';
    return _message.success({
      content: content,
      key: key,
      duration: 2
    });
  },
  confirm: function confirm(content) {
    var title = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '请确认';
    var width = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '330px';
    var p = new Promise(function (resolve) {
      var modal = _confirm({
        transitionName: '',
        modalRender: function modalRender() {
          return /*#__PURE__*/React.createElement(XDraggableModal, {
            className: "xinherc-error-box",
            maskClosable: false,
            title: /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(QuestionCircleOutlined, {
              style: {
                marginRight: '4px'
              }
            }), title),
            width: width,
            onCancel: function onCancel() {
              return modal.destroy();
            },
            children: /*#__PURE__*/React.createElement("div", {
              style: {
                color: 'red',
                padding: '12px 10px'
              }
            }, content),
            visible: true,
            footer: /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(_Button, {
              key: "cancel",
              onClick: function onClick() {
                modal.destroy();
              }
            }, "\u53D6\u6D88"), /*#__PURE__*/React.createElement(_Button, {
              icon: /*#__PURE__*/React.createElement(CheckOutlined, null),
              danger: true,
              type: "primary",
              key: "ok",
              onClick: function onClick() {
                resolve('ok');
                modal.destroy();
              }
            }, "\u786E\u5B9A"))
          });
        }
      });
    });
    return p;
  }
};
export default msg;