import React from 'react';
import './styles.less';
interface IProps {
    /**
     * 主题样式
     * @default light
     */
    theme?: 'dark' | 'light';
    /**
     * 是否手动隐藏,默认自动根据环境判断,壳子环境显示,浏览器环境自动隐藏
     */
    hidden?: boolean;
    /**
     * 不显示最小化按钮
     */
    disableMinBtn?: boolean;
    /**
     * 不显示关闭按钮
     */
    disableCloseBtn?: boolean;
    /**
     * 不显示最大化按钮
     */
    disableMaxBtn?: boolean;
    /**
     * 尺寸
     * @default small
     */
    size?: 'large' | 'middle' | 'small';
    /**
     * 样式
     */
    style?: React.CSSProperties;
}
declare const ControlPanel: React.FC<IProps>;
export default ControlPanel;
