import "antd/es/input/style";
import _Input from "antd/es/input";
import "antd/es/tree-select/style";
import _TreeSelect from "antd/es/tree-select";
import "antd/es/switch/style";
import _Switch from "antd/es/switch";
import "antd/es/select/style";
import _Select from "antd/es/select";
import "antd/es/date-picker/style";
import _DatePicker from "antd/es/date-picker";
import "antd/es/input-number/style";
import _InputNumber from "antd/es/input-number";
var _excluded = ["onChange", "formatter"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import locale from 'antd/es/date-picker/locale/zh_CN';
import { isNumber } from 'lodash';
import moment from 'moment';
import React, { useEffect, useState } from 'react';
import "./styles.less";
export default function Index(props) {
  var _useState = useState(''),
    _useState2 = _slicedToArray(_useState, 2),
    cellValue = _useState2[0],
    setCellValue = _useState2[1];
  //@ts-ignore
  var _props$cellEvent = props.cellEvent,
    value = _props$cellEvent.value,
    node = _props$cellEvent.node,
    colDef = _props$cellEvent.colDef,
    rowIndex = _props$cellEvent.rowIndex;
  //@ts-ignore
  var cellEditorParams = colDef.cellEditorParams,
    field = colDef.field;
  var key = "".concat(rowIndex, "_").concat(field);
  // 使用的组件类型
  var cellEditorType = colDef.cellEditor;
  useEffect(function () {
    if (value !== cellValue) {
      setCellValue(value);
    }
  }, [value]);
  var getRendererParams = function getRendererParams(params) {
    switch (cellEditorType) {
      case 'extNumericEditor':
        return params.antdInputNumberProps;
        break;
      case 'extSelectEditor':
        return params.antdSelectProps;
        break;
      case 'extSwitchEditor':
        return params.antdSwitchProps;
        break;
      case 'extTreeSelectEditor':
        return params.antdTreeSelectProps;
        break;
      default:
        break;
    }
    return params || {};
  };
  var updateCellData = function updateCellData(val) {
    setCellValue(val);
    node.setDataValue(colDef.field, val);
  };
  var _getRendererParams = getRendererParams(cellEditorParams),
    _onChange = _getRendererParams.onChange,
    _getRendererParams$fo = _getRendererParams.formatter,
    formatter = _getRendererParams$fo === void 0 ? 'YYYY-MM-DD HH:mm' : _getRendererParams$fo,
    otherProps = _objectWithoutProperties(_getRendererParams, _excluded);
  var cellEditorModule;
  switch (cellEditorType) {
    case 'extNumericEditor':
      cellEditorModule = /*#__PURE__*/React.createElement(_InputNumber, _extends({
        "data-key": key,
        size: "small",
        onChange: function onChange(e) {
          if (isNumber(e)) {
            updateCellData(e);
            _onChange === null || _onChange === void 0 || _onChange(e);
          } else {
            updateCellData('');
            _onChange === null || _onChange === void 0 || _onChange('');
          }
        },
        value: cellValue
      }, otherProps));
      break;
    case 'extDateEditor':
      cellEditorModule = /*#__PURE__*/React.createElement(_DatePicker, _extends({
        "data-key": key,
        locale: locale,
        style: {
          width: '100%'
        },
        formatter: formatter,
        value: cellValue ? moment(cellValue) : '',
        onChange: function onChange(e) {
          var value = e ? moment(e).format(formatter) : '';
          updateCellData(value);
          _onChange === null || _onChange === void 0 || _onChange(value);
        }
      }, otherProps));
      break;
    case 'extSelectEditor':
      cellEditorModule = /*#__PURE__*/React.createElement(_Select, _extends({
        "data-key": key,
        onChange: function onChange(e) {
          updateCellData(e);
          _onChange === null || _onChange === void 0 || _onChange(e);
        },
        value: cellValue,
        size: "small",
        style: {
          width: '100%'
        },
        showSearch: true
      }, otherProps));
      break;
    case 'extSwitchEditor':
      cellEditorModule = /*#__PURE__*/React.createElement(_Switch, _extends({
        checked: cellValue,
        onChange: function onChange(checked) {
          updateCellData(checked);
          _onChange === null || _onChange === void 0 || _onChange(checked);
        }
      }, otherProps));
      break;
    case 'extTreeSelectEditor':
      cellEditorModule = /*#__PURE__*/React.createElement(_TreeSelect, _extends({
        "data-key": key,
        onChange: function onChange(e) {
          updateCellData(e);
          _onChange === null || _onChange === void 0 || _onChange(e);
        },
        value: cellValue,
        size: "small",
        style: {
          width: '100%'
        },
        showSearch: true
      }, otherProps));
      break;
    default:
      cellEditorModule = /*#__PURE__*/React.createElement(_Input, _extends({
        "data-key": key,
        size: "small",
        onChange: function onChange(e) {
          updateCellData(e.target.value);
        },
        value: cellValue
      }, otherProps));
      break;
  }
  return /*#__PURE__*/React.createElement("div", {
    className: "x-data-grid-cellEdit"
  }, cellEditorModule);
}