import "antd/es/select/style";
import _Select from "antd/es/select";
var _excluded = ["onChange"];
/*
 * @Author: chenzenghua
 * @Date: 2023-05-23 19:48:22
 * @LastEditTime: 2023-12-15 14:30:37
 * @LastEditors: chenzenghua
 * @Description:
 */
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { forwardRef, memo, useEffect, useImperativeHandle, useRef, useState } from 'react';
import "./styles.less";
var KEY_BACKSPACE = 'Backspace';
var KEY_DELETE = 'Delete';
var KEY_F2 = 'F2';
export default /*#__PURE__*/memo( /*#__PURE__*/forwardRef(function (props, ref) {
  //@ts-ignore
  var _props$antdSelectProp = props.antdSelectProps,
    _onChange = _props$antdSelectProp.onChange,
    antdSelectProps = _objectWithoutProperties(_props$antdSelectProp, _excluded);
  //@ts-ignore
  var _props$antdSelectProp2 = props.antdSelectProps.options,
    options = _props$antdSelectProp2 === void 0 ? [] : _props$antdSelectProp2;
  //@ts-ignore
  if (typeof props.getOptions === 'function') {
    //@ts-ignore
    options = props.getOptions(props.data) || [];
  }
  var createInitialState = function createInitialState() {
    var startValue;
    var highlightAllOnFocus = true;
    if (props.eventKey === KEY_BACKSPACE || props.eventKey === KEY_DELETE) {
      // if backspace or delete pressed, we clear the cell
      startValue = '';
      // @ts-ignore
    } else if (props.charPress) {
      // if a letter was pressed, we start with the letter
      // @ts-ignore
      startValue = props.charPress;
      highlightAllOnFocus = false;
    } else {
      // otherwise we start with the current value
      startValue = props.value;
      if (props.eventKey === KEY_F2) {
        highlightAllOnFocus = false;
      }
    }
    return {
      value: startValue,
      highlightAllOnFocus: highlightAllOnFocus
    };
  };
  var initialState = createInitialState();
  var _useState = useState(initialState.value),
    _useState2 = _slicedToArray(_useState, 2),
    value = _useState2[0],
    setValue = _useState2[1];
  var _useState3 = useState(initialState.highlightAllOnFocus),
    _useState4 = _slicedToArray(_useState3, 2),
    highlightAllOnFocus = _useState4[0],
    setHighlightAllOnFocus = _useState4[1];
  var refInput = useRef(null);

  // focus on the input
  useEffect(function () {
    var _editFocusCell$column, _props$colDef, _editingCells$, _props$colDef2;
    // get ref from React component
    var eInput = refInput.current;
    var editingCells = props.api.getEditingCells();
    var focusedCell = props.api.getFocusedCell();
    //@ts-ignore
    var editFocusCell = editingCells.find(function (cell) {
      var _cell$column, _focusedCell$column;
      return ((_cell$column = cell.column) === null || _cell$column === void 0 ? void 0 : _cell$column.colId) === (focusedCell === null || focusedCell === void 0 || (_focusedCell$column = focusedCell.column) === null || _focusedCell$column === void 0 ? void 0 : _focusedCell$column.colId);
    });

    // @ts-ignore
    if (
    //@ts-ignore
    editFocusCell && ((_editFocusCell$column = editFocusCell.column) === null || _editFocusCell$column === void 0 ? void 0 : _editFocusCell$column.colId) === ((_props$colDef = props.colDef) === null || _props$colDef === void 0 ? void 0 : _props$colDef.field) ||
    //@ts-ignore
    !editFocusCell && ((_editingCells$ = editingCells[0]) === null || _editingCells$ === void 0 || (_editingCells$ = _editingCells$.column) === null || _editingCells$ === void 0 ? void 0 : _editingCells$.colId) === ((_props$colDef2 = props.colDef) === null || _props$colDef2 === void 0 ? void 0 : _props$colDef2.field)) {
      eInput === null || eInput === void 0 || eInput.focus();
    }

    // eInput.focus()
    if (highlightAllOnFocus) {
      // eInput.select()
      setHighlightAllOnFocus(false);
    } else {
      // when we started editing, we want the caret at the end, not the start.
      // this comes into play in two scenarios:
      //   a) when user hits F2
      //   b) when user hits a printable character
      // const length = eInput?.value ? eInput?.value?.length : 0
      // if (length > 0) {
      //   eInput.setSelectionRange(length, length)
      // }
    }
  }, []);

  /* Component Editor Lifecycle methods */
  useImperativeHandle(ref, function () {
    return {
      // the final value to send to the grid, on completion of editing
      getValue: function getValue() {
        return value;
      } // Gets called once before editing starts, to give editor a chance to
      // cancel the editing before it even starts.
      // isCancelBeforeStart() {
      //   return cancelBeforeStart
      // },
      // Gets called once when editing is finished (eg if Enter is pressed).
      // If you return true, then the result of the edit will be ignored.
      // isCancelAfterEnd() {
      //   // will reject the number if it greater than 1,000,000
      //   // not very practical, but demonstrates the method.
      //   return value > 100
      // },
    };
  });
  return /*#__PURE__*/React.createElement("div", {
    className: "x-data-grid-select-edit"
  }, /*#__PURE__*/React.createElement(_Select, _extends({
    ref: refInput,
    onChange: function onChange(e) {
      setValue(e);
      _onChange === null || _onChange === void 0 || _onChange(e);
    },
    value: value,
    size: "small",
    style: {
      width: '100%'
    },
    showSearch: true
  }, antdSelectProps, {
    options: options
  })));
}));