import "antd/es/switch/style";
import _Switch from "antd/es/switch";
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import React, { forwardRef, memo, useEffect, useImperativeHandle, useRef, useState } from 'react';
import "./styles.less";
var KEY_BACKSPACE = 'Backspace';
var KEY_DELETE = 'Delete';
var KEY_F2 = 'F2';
export default /*#__PURE__*/memo( /*#__PURE__*/forwardRef(function (props, ref) {
  //@ts-ignore
  var antdSwitchProps = props.antdSwitchProps;
  var createInitialState = function createInitialState() {
    var startValue;
    var highlightAllOnFocus = true;
    if (props.eventKey === KEY_BACKSPACE || props.eventKey === KEY_DELETE) {
      // if backspace or delete pressed, we clear the cell
      startValue = '';
      //@ts-ignore
    } else if (props.charPress) {
      // if a letter was pressed, we start with the letter
      //@ts-ignore
      startValue = props.charPress;
      highlightAllOnFocus = false;
    } else {
      // otherwise we start with the current value
      startValue = props.value;
      if (props.eventKey === KEY_F2) {
        highlightAllOnFocus = false;
      }
    }
    return {
      value: startValue,
      highlightAllOnFocus: highlightAllOnFocus
    };
  };
  var initialState = createInitialState();
  var _useState = useState(initialState.value),
    _useState2 = _slicedToArray(_useState, 2),
    value = _useState2[0],
    setValue = _useState2[1];
  var _useState3 = useState(initialState.highlightAllOnFocus),
    _useState4 = _slicedToArray(_useState3, 2),
    highlightAllOnFocus = _useState4[0],
    setHighlightAllOnFocus = _useState4[1];
  var refInput = useRef(null);

  // focus on the input
  useEffect(function () {
    // get ref from React component
    var eInput = refInput.current;
    // eInput.focus()
    if (highlightAllOnFocus) {
      // eInput.select()

      setHighlightAllOnFocus(false);
    } else {}
  }, []);

  /* Component Editor Lifecycle methods */
  useImperativeHandle(ref, function () {
    return {
      // the final value to send to the grid, on completion of editing
      getValue: function getValue() {
        return value;
      } // Gets called once before editing starts, to give editor a chance to
      // cancel the editing before it even starts.
      // isCancelBeforeStart() {
      //   return cancelBeforeStart
      // },
      // Gets called once when editing is finished (eg if Enter is pressed).
      // If you return true, then the result of the edit will be ignored.
      // isCancelAfterEnd() {
      //   // will reject the number if it greater than 1,000,000
      //   // not very practical, but demonstrates the method.
      //   return value > 100
      // },
    };
  });
  return /*#__PURE__*/React.createElement("div", {
    className: "x-data-grid-switch-edit"
  }, /*#__PURE__*/React.createElement(_Switch, _extends({
    checked: value,
    onChange: function onChange(e) {
      setValue(e);
    }
  }, antdSwitchProps)));
}));