function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
/*
 * @Author: chenzenghua
 * @Date: 2021-07-27 09:30:51
 * @Last Modified by: chenzenghua
 * @Last Modified time: 2022-08-18 00:37:22
 */
import { toNumberArray } from "../utils/XFunc";
import { AgGridReact } from 'ag-grid-react';
import { difference, isEmpty, map, max, mean, min, round, sum } from 'lodash';
import moment from 'moment';

// 重写某些属性

export function customAvgAggFunction(params) {
  var res = toNumberArray(params.values);
  if (!res || res.length === 0) {
    return '-';
  } else {
    return round(mean(res), 2);
  }
}
export function customSumAggFunction(params) {
  var res = toNumberArray(params.values);
  if (!res || res.length === 0) {
    return '-';
  } else {
    return round(sum(res), 2);
  }
}
export function customMinAggFunction(params) {
  var res = toNumberArray(params.values);
  if (!res || res.length === 0) {
    return '-';
  } else {
    return round(min(res), 2);
  }
}
export function customMaxAggFunction(params) {
  var res = toNumberArray(params.values);
  if (!res || res.length === 0) {
    return '-';
  } else {
    return round(max(res), 2);
  }
}
export function customStaticGroupAggFunction(params, aggData) {
  if (!aggData || aggData.length == 0) {
    return '-';
  }
  //@ts-ignore
  var col = params.columnApi.columnModel.columnDefs;
  var groupArr = map(col.filter(function (p) {
    return p.enableRowGroup;
  }), function (p) {
    return p.field;
  });
  if (!groupArr || groupArr.length == 0) {
    return '-';
  }
  if (params.rowNode.level === -1) {
    //总计
    var x = aggData === null || aggData === void 0 ? void 0 : aggData.find(function (p) {
      var res = true;
      groupArr.forEach(function (item) {
        if (!isEmpty(p[item])) {
          res = false;
        }
      });
      return res;
    });

    //@ts-ignore
    return x[params.colDef.field] === 0 ? 0 : x[params.colDef.field];
  } else {
    //求小计
    var arr = [];
    var loop = function loop(rowNode) {
      arr.push({
        key: rowNode.field,
        value: rowNode.key
      });
      if (rowNode.parent && rowNode.parent.level !== -1) {
        loop(rowNode.parent);
      }
    };
    loop(params.rowNode);
    var _x = aggData;
    arr.forEach(function (item) {
      _x = _x.filter(function (p) {
        return p[item.key] === item.value;
      });
    });
    if (!_x || _x.length == 0) {
      return '-';
    } else {
      //分组条件中的其他项目需要为空
      var diffItem = difference(groupArr, map(arr, function (p) {
        return p.key;
      }));
      var matchItem = _x.find(function (p) {
        var res = true;
        diffItem.forEach(function (item) {
          if (!isEmpty(p[item])) {
            res = false;
          }
        });
        return res;
      });
      if (matchItem) {
        //@ts-ignore
        return matchItem[params.colDef.field] === 0 ? 0 : matchItem[params.colDef.field];
      }
      return '-';
    }
  }
}

/**
 * 列类型定义
 * 带 * 号的为非原生属性
 */

export var columnTypes = {
  nonEditableColumn: {
    editable: false
  },
  number: {
    filter: 'agNumberColumnFilter',
    filterParams: {
      filterOptions: [{
        displayKey: '小于',
        displayName: '小于',
        //@ts-ignore
        predicate: function predicate(_ref, cellValue) {
          var _ref2 = _slicedToArray(_ref, 1),
            filterValue = _ref2[0];
          return Number(cellValue) < Number(filterValue);
        }
      }, {
        displayKey: '小于等于',
        displayName: '小于等于',
        //@ts-ignore
        predicate: function predicate(_ref3, cellValue) {
          var _ref4 = _slicedToArray(_ref3, 1),
            filterValue = _ref4[0];
          return Number(cellValue) <= Number(filterValue);
        }
      }, {
        displayKey: '大于',
        displayName: '大于',
        //@ts-ignore
        predicate: function predicate(_ref5, cellValue) {
          var _ref6 = _slicedToArray(_ref5, 1),
            filterValue = _ref6[0];
          return Number(cellValue) > Number(filterValue);
        }
      }, {
        displayKey: '大于等于',
        displayName: '大于等于',
        //@ts-ignore
        predicate: function predicate(_ref7, cellValue) {
          var _ref8 = _slicedToArray(_ref7, 1),
            filterValue = _ref8[0];
          return Number(cellValue) >= Number(filterValue);
        }
      }, {
        displayKey: '等于',
        displayName: '等于',
        //@ts-ignore
        predicate: function predicate(_ref9, cellValue) {
          var _ref10 = _slicedToArray(_ref9, 1),
            filterValue = _ref10[0];
          return Number(cellValue) === Number(filterValue);
        }
      }, {
        displayKey: '不等于',
        displayName: '不等于',
        //@ts-ignore
        predicate: function predicate(_ref11, cellValue) {
          var _ref12 = _slicedToArray(_ref11, 1),
            filterValue = _ref12[0];
          return Number(cellValue) !== Number(filterValue);
        }
      }, {
        displayKey: '在范围内',
        displayName: '在范围内',
        //@ts-ignore
        predicate: function predicate(_ref13, cellValue) {
          var _ref14 = _slicedToArray(_ref13, 2),
            fv1 = _ref14[0],
            fv2 = _ref14[1];
          return Number(fv1) <= Number(cellValue) && Number(fv2) >= Number(cellValue);
        },
        numberOfInputs: 2
      }, 'blank', 'notBlank']
    },
    comparator: function comparator(a, b) {
      return Number(a) - Number(b);
    },
    suppressMenu: false
  },
  date: {
    filter: 'agDateColumnFilter',
    filterParams: {
      filterOptions: [{
        displayKey: '小于',
        displayName: '小于',
        //@ts-ignore
        predicate: function predicate(_ref15, cellValue) {
          var _ref16 = _slicedToArray(_ref15, 1),
            filterValue = _ref16[0];
          var diff = moment(cellValue).diff(moment(filterValue));
          return diff < 0;
        }
      }, {
        displayKey: '小于等于',
        displayName: '小于等于',
        //@ts-ignore
        predicate: function predicate(_ref17, cellValue) {
          var _ref18 = _slicedToArray(_ref17, 1),
            filterValue = _ref18[0];
          var diff = moment(cellValue).diff(moment(filterValue));
          return diff <= 0;
        }
      }, {
        displayKey: '大于',
        displayName: '大于',
        //@ts-ignore
        predicate: function predicate(_ref19, cellValue) {
          var _ref20 = _slicedToArray(_ref19, 1),
            filterValue = _ref20[0];
          var diff = moment(cellValue).diff(moment(filterValue));
          return diff > 0;
        }
      }, {
        displayKey: '大于等于',
        displayName: '大于等于',
        //@ts-ignore
        predicate: function predicate(_ref21, cellValue) {
          var _ref22 = _slicedToArray(_ref21, 1),
            filterValue = _ref22[0];
          var diff = moment(cellValue).diff(moment(filterValue));
          return diff >= 0;
        }
      }, {
        displayKey: '等于',
        displayName: '等于',
        //@ts-ignore
        predicate: function predicate(_ref23, cellValue) {
          var _ref24 = _slicedToArray(_ref23, 1),
            filterValue = _ref24[0];
          var diff = moment(cellValue).diff(moment(filterValue));
          return diff === 0;
        }
      }, {
        displayKey: '不等于',
        displayName: '不等于',
        //@ts-ignore
        predicate: function predicate(_ref25, cellValue) {
          var _ref26 = _slicedToArray(_ref25, 1),
            filterValue = _ref26[0];
          var diff = moment(cellValue).diff(moment(filterValue));
          return diff !== 0;
        }
      }, 'blank', 'notBlank']
    },
    comparator: function comparator(a, b) {
      return moment(a).diff(moment(b));
    },
    suppressMenu: false
  }
};