import moment from 'moment';
import React from 'react';
import '../XDatePicker/datepicker.less';
import './styles.less';
export interface IPropsState {
    onChange?: (val: [moment.Moment, moment.Moment] | []) => void;
    /** moment [开始时间,结束时间] */
    value?: moment.Moment[];
    /** 显示时间 */
    showTime?: boolean;
    /** 显示快捷时间范围选择 */
    showShortCut?: boolean;
    /** 自定义需要显示的快捷选择 */
    shortcutList?: TypeSupportShortcut[];
    /** 快捷选择后不关闭 */
    visibleAfterShortCut?: boolean;
    /** 隐藏日期面板 */
    hidePickPanel?: boolean;
    /** 显示选择面板 默认flase */
    visible?: boolean;
    children?: React.ReactNode;
    /** 关闭后回调 */
    onClose?: () => void;
    /**是否分多行显示 */
    mutipleRow?: boolean;
    /** 前缀1 */
    prefix?: React.ReactNode;
    /**前缀2 */
    prefix2?: React.ReactNode;
    /**
     * 小号尺寸
     */
    smallsize?: boolean;
    /**
     * 弹层左偏移 可以为负数
     */
    left?: number;
    /**
     * 弹层上偏移 可以为负数
     */
    top?: number;
    disabled?: boolean;
    /**
     * 允许往前选的年的数量 默认10
     * @default 10
     */
    yearSelectorPreCount?: number;
    /**
     * 允许往后选的年的数量 默认2
     * @default 2
     */
    yearSelectorSubCount?: number;
    /**
     * 时间选择间隔(分)
     * @default 30
     */
    timeIntervals?: number;
    /**
     * 弹出日历和关闭日历的回调
     */
    onOpenChange?: (visible: any) => void;
    /**
     * 可选最小时间
     */
    minDate?: moment.Moment;
    /**
     * 可选最大时间
     */
    maxDate?: moment.Moment;
    /**
     * 清除按钮
     */
    allowClear?: boolean;
}
type TypeSupportShortcutCustom = () => {
    name: string;
    dateRange: moment.Moment[];
};
/**
 * 已支持的内置快捷方式;
 * 如果需要自定义,请传入自定义函数返回 需返回{ name: string; dateRange: moment.Moment[] }
 */
type TypeSupportShortcut = '今天' | '昨天' | '本周' | '近三天' | '近七天' | '上一周' | '近一周' | '本月' | '上一月' | '近一月' | '近三月' | '本季度' | '上季度' | '一季度' | '二季度' | '三季度' | '四季度' | '今年' | '上半年' | '下半年' | '上一年' | '近一年' | '近两年' | '近三年' | TypeSupportShortcutCustom;
export default function Index(props: IPropsState): React.JSX.Element;
export {};
