import type { ModalProps } from 'antd';
import React from 'react';
import { DraggableEvent } from 'react-draggable';
import './styles.less';
export interface IProps {
    /** @description 自定义标题 */
    title?: React.ReactNode;
    children?: React.ReactNode;
    /**
     * @description 自定义foot
     * @default null
     */
    footer?: React.ReactNode;
    /**
     * @description 关闭时回调
     */
    onCancel?: () => void;
    /**
     * @description 是否点击蒙层关闭
     * @default true
     */
    maskClosable?: boolean;
    width?: string | number;
    height?: string | number;
    destroyOnClose?: boolean;
    visible?: boolean;
    /**
     *@description 是否隐藏标题栏
     */
    hiddenTitle?: boolean;
    /**
     * @description 显示关闭按钮
     */
    closable?: boolean;
    /**
     * @description是否显示蒙层
     */
    mask?: boolean;
    bodyStyle?: React.CSSProperties;
    /**
     * 透传antd modal 属性
     */
    modalProperties?: ModalProps;
    /**
     * 拖动开始事件
     */
    onStart?: (e: DraggableEvent) => void;
    /**
     * 拖动结束事件
     */
    onStop?: (e: DraggableEvent) => void;
    /** 初始位置 */
    defaultPosition?: {
        x: number;
        y: number;
    };
    className?: string;
    sizeControl?: boolean;
}
declare const DraggableModal: (props: IProps) => React.JSX.Element;
export default DraggableModal;
