import React from 'react';
import { DraggableEvent } from 'react-draggable';
export interface IProps {
    children?: React.ReactNode;
    /** 初始位置 */
    defaultPosition?: {
        x: number;
        y: number;
    };
    /**
     * @description 移动边界
     * @description parent需要限制的目标父容器定义 position: 'relative'
     * @description  body跟 父容器定义 position: 'relative' 可能有冲突
     */
    bounds?: 'parent' | 'body';
    /**
     * 拖动开始事件
     */
    onStart?: (e: DraggableEvent) => void;
    /**
     * 拖动结束事件
     */
    onStop?: (e: DraggableEvent) => void;
}
declare const XFloatPanel: (props: IProps) => React.JSX.Element;
export default XFloatPanel;
