import React from 'react';
import './styles.less';
interface IProps {
    open?: boolean;
    /**
     * 锁定人
     */
    userName?: string;
    /** 解锁时回调 回传密码 */
    onUnlock?: (password: string) => Promise<string>;
    /**
     * 切换用户
     */
    onSwitchUser?: () => void;
    /**
     * placeholder内容
     * @default 键入登陆密码解锁
     */
    placeholder?: string;
    /**
     * 提示区信息
     * @default '不得擅自离岗，一经发现，严肃处理！'
     */
    tips?: React.ReactNode;
    /**
     * 隐藏提示区
     * @default false
     */
    hiddenTips?: boolean;
    titleOption?: {
        content: string;
        iconStyle: React.CSSProperties;
        fontStyle: React.CSSProperties;
    };
    contentOption?: {
        content: string;
        fontStyle: React.CSSProperties;
    };
}
declare const LockScreen: React.FC<IProps>;
export default LockScreen;
