/// <reference types="react" />
import { ItemType } from "antd/lib/menu/hooks/useItems";
export interface XTypeMenu {
    /** 主键  必须 */
    key: string;
    label?: string;
    /** 图标 传入 */
    icon?: React.ReactNode;
    /**URL地址 */
    url?: string;
    /** 子菜单 */
    children?: XTypeMenu[];
    /**其他参数 */
    [key: string]: any;
}
export interface IXNavMenuProps {
    menuProps: any;
    /**
     * 菜单项
     */
    menus: ItemType[];
    /**
     * 底部菜单项
     */
    bottomMenus?: ItemType[];
    /**
     * 底部菜单高度
     * @default '100px'
     */
    bottomMenuHeight?: string;
    /** 收起时logo */
    collapsedLogo?: React.ReactNode;
    /** 展开时logo,默认=收起时Logo */
    expandedLogo?: React.ReactNode;
    /**
     * 主题色
     * @default 'dark'
     */
    theme?: 'dark' | 'light';
    /** 菜单点击事件 返回key值 和keypath值 */
    onMenuClick?: (menu?: XTypeMenu, key?: any, keyPath?: any[]) => void;
    /** 选中的菜单  */
    selectedKeys?: string[] | undefined;
    /** 默认选中的菜单 */
    defaultSelectedKeys?: string[] | undefined;
    className?: string | undefined;
    style?: React.CSSProperties;
    /** 自动跳转? 需定义URL */
    autoRedirect?: boolean;
    /** 是否收起 */
    collapased?: boolean;
    /**
     * 是否隐藏下方折叠控制按钮
     * @default false
     */
    hideTrigger?: boolean;
    /**
     * 隐藏顶部logo区
     * @default false
     */
    hideTopLogo?: boolean;
    /**
     * 隐藏底部logo区
     * @default false
     */
    hideBottomLog?: boolean;
    /**
     * 三级菜单显示方式
     * @default 'inline'
     */
    level3MenuMode?: 'inline' | 'popup';
}
