export var getMatchOperatorList = function getMatchOperatorList(inputType) {
  var operatortList = [{
    name: '=',
    label: '等于'
  }, {
    name: '!=',
    label: '不等于'
  }, {
    name: '<',
    label: '小于'
  }, {
    name: '>',
    label: '大于'
  }, {
    name: '<=',
    label: '小于等于'
  }, {
    name: '>=',
    label: '大于等于'
  }, {
    name: 'contains',
    label: '包含'
  }, {
    name: 'doesNotContain',
    label: '不包含'
  }, {
    name: 'like',
    label: '类似'
  }, {
    name: 'doesNotLike',
    label: '不类似'
  }, {
    name: 'completeMatch',
    label: '完全匹配'
  }, {
    name: 'completeNotMatch',
    label: '完全不匹配'
  }, {
    name: 'partMatch',
    label: '部分匹配'
  }, {
    name: 'partNotMatch',
    label: '部分不匹配'
  }];
  switch (inputType) {
    case 'TEXT':
      return [{
        name: '=',
        label: '等于'
      }, {
        name: '!=',
        label: '不等于'
      }, {
        name: 'contains',
        label: '包含'
      }, {
        name: 'doesNotContain',
        label: '不包含'
      }];
    case 'SELECT':
      return [{
        name: '=',
        label: '等于'
      }, {
        name: '!=',
        label: '不等于'
      }, {
        name: 'like',
        label: '类似'
      }, {
        name: 'doesNotLike',
        label: '不类似'
      }, {
        name: 'completeMatch',
        label: '完全匹配'
      }, {
        name: 'completeNotMatch',
        label: '完全不匹配'
      }, {
        name: 'partMatch',
        label: '部分匹配'
      }, {
        name: 'partNotMatch',
        label: '部分不匹配'
      }];
    case 'MULTIPLE_SELECT':
      return [{
        name: '=',
        label: '等于'
      }, {
        name: '!=',
        label: '不等于'
      }, {
        name: 'contains',
        label: '包含'
      }, {
        name: 'doesNotContain',
        label: '不包含'
      }, {
        name: 'like',
        label: '类似'
      }, {
        name: 'doesNotLike',
        label: '不类似'
      }, {
        name: 'completeMatch',
        label: '完全匹配'
      }, {
        name: 'completeNotMatch',
        label: '完全不匹配'
      }, {
        name: 'partMatch',
        label: '部分匹配'
      }, {
        name: 'partNotMatch',
        label: '部分不匹配'
      }];
    case 'NUMBER':
      return [{
        name: '=',
        label: '等于'
      }, {
        name: '!=',
        label: '不等于'
      }, {
        name: '<',
        label: '小于'
      }, {
        name: '>',
        label: '大于'
      }, {
        name: '<=',
        label: '小于等于'
      }, {
        name: '>=',
        label: '大于等于'
      }];
    case 'DATE':
    case 'DATE_TIME':
      return [{
        name: '=',
        label: '等于'
      }, {
        name: '!=',
        label: '不等于'
      }, {
        name: '<',
        label: '小于'
      }, {
        name: '>',
        label: '大于'
      }, {
        name: '<=',
        label: '小于等于'
      }, {
        name: '>=',
        label: '大于等于'
      }
      // { name: 'between', label: '在..之间' },
      // { name: 'notBetween', label: '不在..之间' },
      ];
    default:
      return [{
        name: '=',
        label: '等于'
      }, {
        name: '!=',
        label: '不等于'
      }];
      break;
  }
};