/// <reference types="react" />
import type { GridApi, GridOptions } from 'ag-grid-community';
import type { AgGridColDef } from '..';
export declare class ISelectRef {
    /**
     * 表格api
     **/
    gridApi: GridApi;
    /**
     *获取值
     */
    getValue: () => void;
    /**
     *设置内容
     */
    setValue: (selects: any[], inputs: any[]) => void;
    /**
     * 清理值
     */
    clearValue: () => void;
}
export interface XSelectProps {
    /**
     * 主键字段(必须)
     */
    valueRow: string;
    /**
     * 显示字段(必须)
     */
    nameRow: string;
    /**
     * 多选|tag|不传为单选
     * @default undefined
     */
    mode?: 'multiple' | 'tags' | undefined;
    /**
     * 最多展示多少个选项
     */
    maxTagCount?: number;
    /**
     * 表格列定义
     */
    colDef: AgGridColDef[];
    /**
     * 表格自定义配置信息
     */
    gridOptions?: GridOptions;
    /**
     * 状态栏额外内容
     */
    statusBarExtra?: React.ReactNode;
    /**
     * 展示数据
     */
    data?: any[];
    onSelectChange?: (value: any) => void;
    placeholder?: string;
    style?: React.CSSProperties;
    dropdownMatchSelectWidth?: boolean;
    dropdownStyle?: React.CSSProperties;
    onClick?: () => void;
    allowClear?: boolean;
    showSearch?: boolean;
    enterAdd?: boolean;
    /**
     * 默认选中数据 valueRow 数组
     */
    defaultValue?: any[];
    onDropdownOpen?: (open: boolean) => void;
    disabled?: boolean;
    popupMatchSelectWidth?: boolean | number;
}
