import React from 'react';
import './styles.less';
interface IProps {
    /**
     * 方向 horizontal|vertical
     * @default horizontal
     */
    direction?: 'horizontal' | 'vertical';
    /**
     * 拖动步进(默认1px)
     */
    dragInterval?: number | undefined;
    /**
     * 初始大小
     * @default 均分
     */
    sizes?: number[] | undefined;
    /**
     * 默认最小宽/高 传入number时,统一最小值传入number[] 分别定义
     * @default 100
     */
    minSize?: number | number[] | undefined;
    /**
     * 元素间隔大小
     * @default 4px
     */
    gutterSize?: number;
    /**
     * 子元素块,通常为div
     */
    children: React.ReactNode;
}
export default function Index(props: IProps): React.JSX.Element;
export {};
