import { useEvent } from 'rc-util';
import * as React from 'react';
function voidFunc() {}
var WatermarkContext = /*#__PURE__*/React.createContext({
  add: voidFunc,
  remove: voidFunc
});
export function usePanelRef(panelSelector) {
  var watermark = React.useContext(WatermarkContext);
  var panelEleRef = React.useRef();
  var panelRef = useEvent(function (ele) {
    if (ele) {
      var innerContentEle = panelSelector ? ele.querySelector(panelSelector) : ele;
      watermark.add(innerContentEle);
      panelEleRef.current = innerContentEle;
    } else {
      watermark.remove(panelEleRef.current);
    }
  });
  return panelRef;
}
export default WatermarkContext;