import React from 'react';
import raf from 'rc-util/lib/raf';
import { useEvent } from 'rc-util';

/**
 * Callback will only execute last one for each raf
 */
export default function useRafDebounce(callback) {
  var executeRef = React.useRef(false);
  var rafRef = React.useRef();
  var wrapperCallback = useEvent(callback);
  return function () {
    if (executeRef.current) {
      return;
    }
    executeRef.current = true;
    wrapperCallback();
    rafRef.current = raf(function () {
      executeRef.current = false;
    });
  };
}