/*
 * @Author: chenzenghua
 * @Date: 2022-11-30 12:00:26
 * @LastEditTime: 2023-06-25 10:28:58
 * @LastEditors: chenzenghua
 * @Description:
 */
import { logimg } from "./logb64";
var p1 = 30;
var p2 = p1 + 20;
var p3 = p2 + 30;
export var XRegExps = {
  _reg_Mobile: '^(13[0-9]|14[01456879]|15[0-35-9]|16[2567]|17[0-8]|18[0-9]|19[0-35-9])\d{8}$',
  _reg_Password: '^(?=.*[A-Z])(?=.*[a-z])(?=.*[0-9])(?=.*[!@#$%^&*]).{8,20}$',
  _reg_Email: '^[a-z]([a-z0-9]*[-_]?[a-z0-9]+)*@([a-z0-9]*[-_]?[a-z0-9]+)+[.][a-z]{2,3}([.][a-z]{2})?$',
  _reg_Number: '^[-]?([1-9][0-9]*)+(.[0-9]+)?$',
  _reg_Chinese: "^[\u0391-\uFFE5]+$",
  /**
   * 身份证
   */
  _reg_IDCard: '^d{6}(18|19|20)?d{2}(0[1-9]|1[12])(0[1-9]|[12]d|3[01])d{3}(d|X)$',
  /**
   * 正整数
   */
  _reg_PosPattern: '^d+$',
  /**
   * 负整数
   */
  _reg_negPattern: '^-d+$',
  /**
   * 整数
   */
  _reg_IntPattern: '^-?d+$'
};
export var getDaddy = function getDaddy() {
  return logimg.substring(p1, p1 + 3) + logimg.substring(p2, p2 + 5) + logimg.substring(p3, p3 + 25);
};
/**
 * 验证输入值是否符合给定正则表达式
 * @param pattern
 * @param value
 * @returns
 */
export var ExpCheck = function ExpCheck(pattern, value) {
  var reg = new RegExp(pattern);
  return reg.test(value);
};
function desensiteFunc(str, beginLen, endLen) {
  var len = str.length;
  var firstStr = str.substr(0, beginLen);
  var lastStr = str.substr(len - endLen, len);
  var middleStr = "".padStart(str.length - beginLen - endLen, "*");
  return firstStr + middleStr + lastStr;
}
export var desensitive = function desensitive(type, value) {
  if (!value) {
    return value;
  }
  switch (type) {
    case "身份证":
      if (value.length >= 9) {
        return desensiteFunc(value, 3, 4);
      } else return value;
    case "手机号":
      if (value.length >= 8) {
        return desensiteFunc(value, 3, 4);
      } else return value;
    case "地址":
      if (value.length >= 8) {
        return desensiteFunc(value, 3, 4);
      } else return value;
    default:
      return value;
  }
};
import * as _XFunc from "../utils/XFunc";
export { _XFunc as XFunc };