/*
 * @Author: chenzenghua
 * @Date: 2023-04-12 17:08:29
 * @LastEditTime: 2023-04-23 10:18:46
 * @LastEditors: chenzenghua
 * @Description: 
 */

import { isNaN } from "lodash";
import { toNumber } from 'lodash';
var judgeCompareValue = function judgeCompareValue(v1, v2, opt) {
  var compareType = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : "number";
  if (!v1 && toNumber(v1) !== 0 || !v2 && toNumber(v2) !== 0) {
    return false;
  }
  if (isNaN(toNumber(v1)) || isNaN(toNumber(v2))) {
    compareType = "string";
  } else {
    v1 = toNumber(v1);
    v2 = toNumber(v2);
  }
  switch (opt) {
    case "大于":
      if (compareType === "number") {
        return v1 > v2;
      } else if (compareType === "string") {
        return v1.toString().localeCompare(v2) > 0;
      }
      break;
    case "大于等于":
      if (compareType === "number") {
        return v1 >= v2;
      } else if (compareType === "string") {
        return v1.toString().localeCompare(v2) >= 0;
      }
      break;
    case "小于":
      if (compareType === "number") {
        return v1 < v2;
      } else if (compareType === "string") {
        return v1.toString().localeCompare(v2) < 0;
      }
      break;
    case "小于等于":
      if (compareType === "number") {
        return v1 <= v2;
      } else if (compareType === "string") {
        return v1.toString().localeCompare(v2) <= 0;
      }
      break;
    case "等于":
      return v1 === v2;
    case "不等于":
      return v1 != v2;
    default:
      break;
  }
};
export { judgeCompareValue };